#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include <QGroupBox>
#include <QStyle>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QLabel>
#include <QDebug>
#include <QPushButton>
#include <QDialog>
#include <QWidget>
#include <QApplication>
#include <QObject>
#include <QDateTime>
#include <QDate>
#include <QTime>

#include <QPluginLoader>
#include <QDir>
#include "plugin.h"
#include "stepList.h"
//#include "stepList.h" // define all working chain steps here
#include "win01_com.h"


class MainWindow : public QMainWindow
{
    Q_OBJECT

    QPushButton *pBback;
    QPushButton *pBhome;
    QPushButton *pBforward;
    QGroupBox   *bigGroupbox;
    QHBoxLayout *bigLayout;
    QTimer      *timerChainCtrl;
    QTimer      *timerVendingTimeout;

    QGroupBox   *frame01;
    T_winComPort    *myFenster01;

    void HideAllWindows();
    void switchScreen(uint16_t winNr);
    char loadPlugIn(char lade1_entlade2);
    QDir plugInDir;
    void chainIni(void);

public:
    hwinf *HWaccess=nullptr;        // global pointer to plugin-class

    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

#define BACKBUTTON  1
#define HOMEBUTTON  2
#define FORWBUTTON  3
    void enableNaviButtons(uint8_t buttonNr, bool enabled);
    void enableNaviButtons(uint8_t switchBitwise);

private slots:
    void chainControl();
    void vendingTimeout();

};




#endif // MAINWINDOW_H
