#ifndef STEPLIST_H
#define STEPLIST_H


// define all working chain steps
// every FSM-Step get's a frame in MainWindow with the same number and a self-designed GUI
// labels are used for switchScreen( label=nr );
// numbers are important: e.g. number 3 calls frame3 and frame3 includes subClass "T_fenster03"
// so best solution: label = same name like class (in example: Fenster03). Label is fixed bound to number, never change!

// numbers are fixed assosiated with the function (e.g. ComPort), can't be changed.
// but screen order can be called in step chain randomly


// Windownumbers for certain function, never change
#define     PAGE_COMPORT            1
#define     PAGE_SERVICEMAIN        2
#define     PAGE_TIMEDATEVERSION    3
#define     PAGE_MACHINESTATUS      4
#define     PAGE_CHECKDOORS         5
#define     PAGE_PRINTER            6
#define     PAGE_COINMECHANIC       7
#define     PAGE_MIFARE             8
#define     PAGE_MODEM              9
#define     PAGE_COINPAYMENT        10
#define     PAGE_VAULTRECORD        11
#define     PAGE_BOOTLOADER         12
#define     PAGE_PROG_JSON          13
#define     PAGE_COINCHANGER        14
#define     PAGE_BILLREADER         15
#define     PAGE_NEXT16             16
#define     PAGE_NEXT17             17
#define     PAGE_NEXT18             18
#define     PAGE_NEXT19             19
#define     PAGE_NEXT20             20

//          fix:                customize:
#define     WCS_STARTSCREEN     PAGE_COMPORT

// PAGE_COMPORT:
#define     WCS_WIN01BAK    PAGE_COMPORT
#define     WCS_WIN01MID    PAGE_SERVICEMAIN
#define     WCS_WIN01FWD    PAGE_SERVICEMAIN

// PAGE_SERVICEMAIN:
#define     WCS_WIN02BAK    PAGE_COMPORT
#define     WCS_WIN02MID    PAGE_SERVICEMAIN
#define     WCS_WIN02FWD    PAGE_TIMEDATEVERSION

// PAGE_TIMEDATEVERSION:
#define     WCS_WIN03BAK    PAGE_SERVICEMAIN
#define     WCS_WIN03MID    PAGE_SERVICEMAIN
#define     WCS_WIN03FWD    PAGE_MACHINESTATUS

// PAGE_MACHINESTATUS:
#define     WCS_WIN04BAK    PAGE_TIMEDATEVERSION
#define     WCS_WIN04MID    PAGE_SERVICEMAIN
#define     WCS_WIN04FWD    PAGE_CHECKDOORS


// PAGE_CHECKDOORS:
#define     WCS_WIN05BAK    PAGE_MACHINESTATUS
#define     WCS_WIN05MID    PAGE_SERVICEMAIN
#define     WCS_WIN05FWD    PAGE_COINMECHANIC

// PAGE_COINMECHANIC:
#define     WCS_WIN07BAK    PAGE_CHECKDOORS
#define     WCS_WIN07MID    PAGE_SERVICEMAIN
#define     WCS_WIN07FWD    PAGE_COINPAYMENT

// PAGE_COINPAYMENT:
#define     WCS_WIN10BAK    PAGE_COINMECHANIC
#define     WCS_WIN10MID    PAGE_SERVICEMAIN
#define     WCS_WIN10FWD    PAGE_COINCHANGER

// PAGE_COINCHANGER:
#define     WCS_WIN14BAK    PAGE_COINPAYMENT
#define     WCS_WIN14MID    PAGE_SERVICEMAIN
#define     WCS_WIN14FWD    PAGE_BILLREADER


// PAGE_BILLREADER:
#define     WCS_WIN15BAK    PAGE_COINCHANGER
#define     WCS_WIN15MID    PAGE_SERVICEMAIN
#define     WCS_WIN15FWD    PAGE_PRINTER

// PAGE_PRINTER:
#define     WCS_WIN06BAK    PAGE_BILLREADER
#define     WCS_WIN06MID    PAGE_SERVICEMAIN
#define     WCS_WIN06FWD    PAGE_MIFARE

// PAGE_MIFARE:
#define     WCS_WIN08BAK    PAGE_PRINTER
#define     WCS_WIN08MID    PAGE_SERVICEMAIN
#define     WCS_WIN08FWD    PAGE_MODEM

// PAGE_MODEM:
#define     WCS_WIN09BAK    PAGE_MIFARE
#define     WCS_WIN09MID    PAGE_SERVICEMAIN
#define     WCS_WIN09FWD    PAGE_VAULTRECORD


// PAGE_VAULTRECORD:
#define     WCS_WIN11BAK    PAGE_MODEM
#define     WCS_WIN11MID    PAGE_SERVICEMAIN
#define     WCS_WIN11FWD    PAGE_PROG_JSON

// PAGE_PROG_JSON:
#define     WCS_WIN13BAK    PAGE_VAULTRECORD
#define     WCS_WIN13MID    PAGE_SERVICEMAIN
#define     WCS_WIN13FWD    PAGE_BOOTLOADER

// PAGE_BOOTLOADER:
#define     WCS_WIN12BAK    PAGE_PROG_JSON
#define     WCS_WIN12MID    PAGE_SERVICEMAIN
#define     WCS_WIN12FWD    PAGE_NEXT16


// PAGE_NEXT16
#define     WCS_WIN16BAK    PAGE_BOOTLOADER
#define     WCS_WIN16MID    PAGE_SERVICEMAIN
#define     WCS_WIN16FWD    PAGE_NEXT17

// PAGE_NEXT17
#define     WCS_WIN17BAK    PAGE_NEXT16
#define     WCS_WIN17MID    PAGE_SERVICEMAIN
#define     WCS_WIN17FWD    PAGE_NEXT18

// PAGE_NEXT18
#define     WCS_WIN18BAK    PAGE_NEXT17
#define     WCS_WIN18MID    PAGE_SERVICEMAIN
#define     WCS_WIN18FWD    PAGE_NEXT19

// PAGE_NEXT19
#define     WCS_WIN19BAK    PAGE_NEXT18
#define     WCS_WIN19MID    PAGE_SERVICEMAIN
#define     WCS_WIN19FWD    PAGE_NEXT20

// PAGE_NEXT20
#define     WCS_WIN20BAK    PAGE_NEXT19
#define     WCS_WIN20MID    PAGE_SERVICEMAIN
#define     WCS_WIN20FWD    PAGE_SERVICEMAIN

// just for Template
#define     WCS_WIN99BAK    PAGE_SERVICEMAIN
#define     WCS_WIN99MID    PAGE_SERVICEMAIN
#define     WCS_WIN99FWD    PAGE_SERVICEMAIN



#define     WIN02_LABEL_SHORT01     " Status"
#define     WCS_WIN02SHORT01    PAGE_MACHINESTATUS
#define     WIN02_LABEL_SHORT02     " Doors "
#define     WCS_WIN02SHORT02    PAGE_CHECKDOORS
#define     WIN02_LABEL_SHORT03     "Coin mech"
#define     WCS_WIN02SHORT03    PAGE_COINMECHANIC
#define     WIN02_LABEL_SHORT04     "Payment"
#define     WCS_WIN02SHORT04    PAGE_COINPAYMENT

#define     WIN02_LABEL_SHORT05     "Changer"
#define     WCS_WIN02SHORT05    PAGE_COINCHANGER
#define     WIN02_LABEL_SHORT06     " Bill  "
#define     WCS_WIN02SHORT06    PAGE_BILLREADER
#define     WIN02_LABEL_SHORT07     "Printer"
#define     WCS_WIN02SHORT07    PAGE_PRINTER

#define     WIN02_LABEL_SHORT08     "Program"
#define     WCS_WIN02SHORT08    PAGE_VAULTRECORD
#define     WIN02_LABEL_SHORT09     "      "
#define     WCS_WIN02SHORT09    PAGE_SERVICEMAIN
#define     WIN02_LABEL_SHORT10     "      "
#define     WCS_WIN02SHORT10    PAGE_SERVICEMAIN







// set needed navigation buttons, use | to combine more then one:
#define     SWITCH_NEXT_ON      1
#define     SWITCH_NEXT_OFF     2
#define     SWITCH_HOME_ON      4
#define     SWITCH_HOME_OFF     8
#define     SWITCH_BACK_ON      16
#define     SWITCH_BACK_OFF     32
// example: *useNavi=SWITCH_BACK_ON;   // change only this one, or set all:
//          *useNavi=SWITCH_BACK_OFF | SWITCH_HOME_OFF | SWITCH_NEXT_ON;



// some defines for Widget design:

#define     TS_VALUEBOX_FRAMESTYLE      0x0032
#define     TS_VALUEBOX_LINEWIDTH       3

//genDatPort->setFrameStyle(QFrame::Panel |  QFrame::Sunken ); funktioniert aber gibt unverständliche Warnung
// QFrame::Panel = 0x0002    QFrame::Sunken=0x0030
//genDatPort->setFrameStyle(0x0032);      //  funktioniert und gibt keine Warnung
//genDatPort->setFrameStyle(TS_VALUEBOX_FRAMESTYLE);      //  funktioniert und gibt keine Warnung

#define     TS_LED_FRAMESTYLE      0x0031
// QFrame::Box | QFrame::Sunken






#endif // STEPLIST_H
