
#ifndef RUN_PROCESS_H
#define RUN_PROCESS_H

#include <stdint.h>
#include <QMainWindow>
#include <QString>
#include <QTimer>
#include "tslib.h"
#include "com.h"
#include "interfaces.h"

#include <QtPlugin>
#include <QObject>
#include <QDebug>
#include "datIf.h"
#include <QSharedMemory>
#include "sendWRcmd.h"
#include "controlBus.h"
#include "storeINdata.h"
#include "dcBL.h"
#include "shared_mem_buffer.h"



class T_runProc : public QObject
{
    Q_OBJECT
    QTimer *hwapi_TimerPayment, *hwapi_triggerBL, *myTO;

    void sub_emp_getAllParameters(struct T_emp *emp);
    void changer_getAllParameters(struct T_changer *mw);

    void sub_getDynMachineConditions(struct T_dynamicCondition *dynMachCond);

    void restoreDeviceParameter(struct T_devices *deviceSettings);

private slots:
    void runProc_slotProcess(void);
    bool bl_performComplStart(void);

public:
    T_runProc();

    bool cash_startPayment(uint32_t amount);
    uint8_t cash_paymentProcessing(void);
    uint8_t epi_store64BdevParameter(uint8_t length, uint8_t *buf);
    uint8_t epi_restore64BdevParameter(uint8_t *length, uint8_t *buf);
    bool doors_supervise(void);
    uint8_t prn_getHwState(struct Tprn_hw_state *prn_hw_state);
    void bl_completeStart(void);
    void dc_autoRequest(bool on);
    void bl_rebootDC(void);
    void bl_startBL(void);
    void bl_checkBL(void);
    bool bl_isUp(void);


signals:
    //void runProc_templatePrintFinished_OK(void) const override;
    //void runProc_templatePrintFinished_Err(void) const override;

    void runProc_coinCollectionJustStarted(void);
    void runProc_coinCollectionAborted(void);

    void runProc_gotNewCoin(void);
    void runProc_payStopByMax(void);
    void runProc_payStopByPushbutton(void);

    void runProc_payStopByEscrow(void);
    void runProc_payStopByError(void);
    void runProc_payStopByTimeout(void);
    void runProc_payCancelled(void);
    void runProc_coinProcessJustStopped(void);

    void runProc_doorServiceDoorOpened(void);
    void runProc_doorVaultDoorOpened(void);
    void runProc_doorCoinBoxRemoved(void);
    void runProc_doorCoinBoxInserted(void);
    void runProc_doorCBinAndAllDoorsClosed(void);
    void runProc_doorAllDoorsClosed(void);

};



#endif
